diff --git a/imap/pop3d.c b/imap/pop3d.c
index d9c5ba2edd..df02452939 100644
--- a/imap/pop3d.c
+++ b/imap/pop3d.c
@@ -1228,6 +1228,7 @@ void uidl_msg(uint32_t msgno)
 static void cmd_starttls(int pop3s)
 {
     int result;
+    char *localip, *remoteip;
 
     if (popd_starttls_done == 1)
     {
@@ -1260,12 +1261,23 @@ static void cmd_starttls(int pop3s)
         prot_flush(popd_out);
     }
 
+    /* tls_start_servertls is going to reset saslprops, discarding the
+     * iplocalport and ipremoteport fields.  Preserve them, then put them back
+     * after the call.
+     */
+    localip = buf_release(&saslprops.iplocalport);
+    remoteip = buf_release(&saslprops.ipremoteport);
+
     result=tls_start_servertls(0, /* read */
                                1, /* write */
                                pop3s ? 180 : popd_timeout,
                                &saslprops,
                                &tls_conn);
 
+    /* put the iplocalport and ipremoteport back */
+    if (localip)  buf_initm(&saslprops.iplocalport, localip, strlen(localip));
+    if (remoteip) buf_initm(&saslprops.ipremoteport, remoteip, strlen(remoteip));
+
     /* if error */
     if (result==-1) {
         if (pop3s == 0) {
